FROM rust:1.43.1 AS build

RUN apt-get update && apt-get install -y libclang1 llvm clang

WORKDIR /opt
RUN USER=root cargo new scrap
WORKDIR /opt/scrap
COPY Cargo.toml Cargo.lock ./
COPY service_macro ./service_macro
COPY service_macro_derive ./service_macro_derive
RUN cargo build --release
RUN rm src/*.rs

COPY src ./src

RUN rm ./target/release/deps/service*
RUN cargo build --release

RUN cargo install --locked --path .

FROM rust:1.43.1-slim
COPY --from=build /usr/local/cargo/bin/service .

CMD ["./service"]